// dojstreams - a c++ stream library implementation
//
// Copyright (c) 2003-2004 by Dirk Jagdmann <doj@cubic.org>
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any
// damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any
// purpose, including commercial applications, and to alter it and
// redistribute it freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product
// documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source
// distribution.

#ifndef DS_CONFIG__HPP
#define DS_CONFIG__HPP

#ifndef DS_NAMESPACE
#define DS_NAMESPACE std
#endif

#ifndef DS_STRING_NAMESPACE
#define DS_STRING_NAMESPACE std
#endif

#include <ds_fixcompiler.hpp>

namespace DS_NAMESPACE
{

#ifdef DSDEBUG
  void ds_debughook(const char*, const int=0);

#if defined(__i386__)

#if defined(__GNUC__)
#  define ds_breakpoint asm("int $3")
#endif

#endif

#else
#if defined(_WIN32_WCE)
# define ds_debughook(a,b)
#else
# define ds_debughook(a ...)
#endif
# define ds_breakpoint
#endif

#if defined(_FILE_OFFSET_BITS) && _FILE_OFFSET_BITS==64
  typedef int64_t dojpos_t;
  typedef int64_t dojoff_t;
#else
  typedef int dojpos_t;
  typedef int dojoff_t;
#endif

}

#endif
