// dojstreams - a c++ stream library implementation
//
// Copyright (c) 2003-2004 by Dirk Jagdmann <doj@cubic.org>
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any
// damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any
// purpose, including commercial applications, and to alter it and
// redistribute it freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product
// documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source
// distribution.

#ifndef DS_IOMANIPTYPES__HPP
#define DS_IOMANIPTYPES__HPP

namespace DS_NAMESPACE
{

  class resetiosflags_t
  {
  public:
    ios_base::fmtflags flags;
    resetiosflags_t(ios_base::fmtflags f)
      : flags(f)
    { }
  private:
    resetiosflags_t();
    resetiosflags_t& operator= (const resetiosflags_t&);
  };

  class setiosflags_t
  {
  public:
    ios_base::fmtflags flags;
    setiosflags_t(ios_base::fmtflags f)
      : flags(f)
    { }
  private:
    setiosflags_t();
    setiosflags_t& operator=(const setiosflags_t&);
  };

  class setbase_t
  {
  public:
    int base;
    setbase_t(int b)
      : base(b)
    { }
  private:
    setbase_t();
    setbase_t& operator= (const setbase_t&);
  };

  class setfill_t
  {
  public:
    int fill;
    setfill_t(int f)
      : fill(f)
    { }
  private:
    setfill_t();
    setfill_t& operator= (const setfill_t&);
  };

  class setprecision_t
  {
  public:
    streamsize prec;
    setprecision_t(streamsize p)
      : prec(p)
    { }
  private:
    setprecision_t();
    setprecision_t& operator= (const setprecision_t&);
  };

  class setw_t
  {
  public:
    streamsize width;
    setw_t(streamsize w)
      : width(w)
    { }
  private:
    setw_t();
    setw_t& operator= (const setw_t&);
  };

}

#endif
