// dojstreams - a c++ stream library implementation
//
// Copyright (c) 2003-2004 by Dirk Jagdmann <doj@cubic.org>
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any
// damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any
// purpose, including commercial applications, and to alter it and
// redistribute it freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product
// documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source
// distribution.

#ifndef DS_IOSTREAM__HPP
#define DS_IOSTREAM__HPP

#include <iosfwd>
#include <ds_basicostream.hpp>
#include <ds_basicistream.hpp>
#include <ds_streamiterator.hpp>

namespace DS_NAMESPACE
{
  extern istream cin;
  extern ostream cout;
  extern ostream cerr;
  extern ostream clog;
  extern wistream wcin;
  extern wostream wcout;
  extern wostream wcerr;
  extern wostream wclog;

#if !defined(_WIN32_WCE)
  static ios::Init __cincoutinit;
#endif

  template <TYPENAME charT,
	    TYPENAME _traits
#if defined(__GNUC__)
	    = int
#endif
	    >
  class basic_iostream : public basic_istream<charT, _traits>, public basic_ostream<charT, _traits>
  {
  public:
    basic_iostream<charT, _traits>(basic_streambuf<charT> *s=0)
      : basic_istream<charT, _traits>(s), basic_ostream<charT, _traits>(s)
    { }
  };

  typedef basic_iostream<char> iostream;
  typedef basic_iostream<wchar_t> wiostream;
}

#endif
