// dojstreams - a c++ stream library implementation
//
// Copyright (c) 2003-2004 by Dirk Jagdmann <doj@cubic.org>
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any
// damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any
// purpose, including commercial applications, and to alter it and
// redistribute it freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product
// documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source
// distribution.

#include <ds_basicistream.hpp>
#include <ds_basicostream.hpp>

namespace DS_NAMESPACE
{
#if defined(_WIN32_WCE)
#pragma warning ( disable : 4073 )
#pragma init_seg(lib)
  istream cin;
  ostream cout;
  ostream cerr;
  ostream clog;
  wistream wcin;
  wostream wcout;
  wostream wcerr;
  wostream wclog;
  static ios::Init __cincoutinit;
#else
  typedef char fake_istream[sizeof(istream)];
  typedef char fake_ostream[sizeof(ostream)];
  typedef char fake_wistream[sizeof(wistream)];
  typedef char fake_wostream[sizeof(wostream)];

  fake_istream cin;
  fake_ostream cout;
  fake_ostream cerr;
  fake_ostream clog;

  fake_wistream wcin;
  fake_wostream wcout;
  fake_wostream wcerr;
  fake_wostream wclog;
#endif
}
