// dojstreams - a c++ stream library implementation
//
// Copyright (c) 2003-2004 by Dirk Jagdmann <doj@cubic.org>
//
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any
// damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any
// purpose, including commercial applications, and to alter it and
// redistribute it freely, subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented; you must
// not claim that you wrote the original software. If you use this
// software in a product, an acknowledgment in the product
// documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such, and must
// not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source
// distribution.

#include "inc.hpp"

void teststring()
{
  string a("1");
  string b;
  b+='2';

  cout << (a==b) << endl;
  cout << (a!=b) << endl;
  cout << (a<b) << endl;
  cout << (a>b) << endl;
  cout << (a<=b) << endl;
  cout << (a>=b) << endl;

  string zehn(10, '!');
  cout << zehn << endl;
  string elf(zehn, 1, 20);
  cout << elf << endl;

  zehn.append(elf, 2, 4);
  elf.append(zehn.c_str(), 4, 2345);
  cout << zehn << elf << endl;

  zehn.resize(1024, '?');
  elf.resize(3);

  cout << (zehn+elf) << endl;

  string fox;
  fox="The quick Brown Fox jumps over the Lazy dog.";

  for(string::iterator i=fox.begin(); i<fox.end(); ++i)
    cout << *i;
  cout << endl;

  for(string::reverse_iterator i2=fox.rbegin(); i2!=fox.rend(); ++i2)
    cout << *i2;

  cout << endl;
}
